<?php
function erzeugeFeiertage($Jahr){
    //Feiertage mit festem Datum array(Tag,Monat,Name)
    $FFeiertg[0]=array(1,5,'Tag der Arbeit');
    $FFeiertg[1]=array(3,10,'Tag der deutschen Einheit');
    $FFeiertg[2]=array(25,12,'1. Weihnachtstag');
    $FFeiertg[3]=array(26,12,'2. Weihnachtstag');
    $FFeiertg[4]=array(1,1,'Neujahr');
    //Osterabhaengige Feiertage array(Anzahl Tage nach Ostersonntag,Name)
    $OFeiertg[0]=array(-2,'Karfreitag');
    $OFeiertg[1]=array(0,'Ostersonntag');
    $OFeiertg[2]=array(1,'Ostermontag');
    $OFeiertg[3]=array(39,'Christi Himmelfahrt');
    $OFeiertg[4]=array(49,'Pfingstsonntag');
    $OFeiertg[5]=array(50,'Pfingstmontag');
    $OFeiertg[6]=array(60,'Fronleichnam');
    $i=0;
    foreach ($OFeiertg as $Wert)
    {
        $Ostertag=strftime("%j",oster_datum($Jahr));
        $arrayFT[$i][0]=$Ostertag+$OFeiertg[$i][0];
        $arrayFT[$i][1]=$OFeiertg[$i][1];
        $i++;
    }
    $i=0;
    foreach ($FFeiertg as $Wert)
    {
        $datum=mktime(0,0,0,$FFeiertg[$i][1],$FFeiertg[$i][0],$Jahr);
        $TagDesJahres=strftime("%j",$datum);
        $arr[0]=$TagDesJahres;
        $arr[1]=$FFeiertg[$i][2];
        $n=array_push($arrayFT,$arr);
        $i++;
    }
    array_multisort($arrayFT);
    return $arrayFT;
}
function oster_datum($Jahr)
{
    $Ostern=oster_tage($Jahr);
    return mktime(0,0,0,$Ostern[1],$Ostern[2],$Ostern[0]);
}
function oster_tage($Jahr)
{
    $a = $Jahr % 19; 
    $b = $Jahr % 4; 
    $c = $Jahr % 7; 
    $d = floor(( ( ($Jahr / 100) * 8 ) + 13 ) / 25 - 2); 
    $e = floor($Jahr / 100) - floor($Jahr / 400) - 2; 
    $f = (15 + $e - $d) % 30; 
    $g = (6 + $e) % 7; 
    $h = (19 * $a + $f) % 30; 
    $i = $h; 
    if ($h == 29) { $i = 28; }
    if ( ($h == 28) and ($a > 10) ) { $i = 27; }
    $j = ( (2 * $b) + (4 * $c) + (6 * $i) + $g ) % 7; 
    $OSTERN_GAUSS = $i + $j + 22; 
    if ($OSTERN_GAUSS>31)
    {
        $Tag=$OSTERN_GAUSS-31;
        $Monat=4;    
    }
    else
    {
        $Tag=$OSTERN_GAUSS;
        $Monat=3;
    }
    return array($Jahr,$Monat,$Tag);
}
?>